stages:
  - build
  - trigger
  - publish

include:
  - project: 'postscriptum.app/wsp'
    file: '/tools/ci/1.2/node-pkg.yml'

variables:
  PKG_COMMON_NAME: cli-common
  PKG_COMMON_FILENAME : "postscriptum-${PKG_COMMON_NAME}-${PKG_VERSION}.tar.gz"

build:
  extends: .build
  script:
    - echo $(env | grep -E '^PKG_\w+=')
    - npm install -w common "${PKG_JOB_core_FILE_URL}"
    - cd common
    - npm pack
    - tar -xzf *.tgz
    - mv package "${PKG_COMMON_NAME}"
    - tar -czf "${CI_PROJECT_DIR}/${PKG_COMMON_FILENAME}" "${PKG_COMMON_NAME}"
    - cd ..
    - npm install -w cdp
    - cd cdp
    - if [ -n "${PKG_JOB_core_FILE_URL}${PKG_JOB_postpdf_FILE_URL}" ]; then npm install --ignore-scripts "${PKG_JOB_core_FILE_URL}" "${PKG_JOB_postpdf_FILE_URL}"; fi
    - npm pack
    - !reference [ .rename-npm-pack, script ]
    - export PKG_JOB_COMMON_FILE_URL="${CI_JOB_URL}/artifacts/raw/${PKG_COMMON_FILENAME}"
    - !reference [ .export-pkg-job-vars, script ]
  artifacts:
    name: "${PKG_FILENAME}"
    paths:
      - "${PKG_COMMON_FILENAME}"
      - "${PKG_FILENAME}"
    reports: !reference [ .export-pkg-job-vars, artifacts, reports ]

trigger_app:
  stage: trigger
  except: [ 'tags' ]
  inherit:
    variables: false
  variables:
    PKG_JOB_cli_FILE_URL: "${PKG_JOB_FILE_URL}"
    PKG_JOB_cli_common_FILE_URL: "${PKG_JOB_COMMON_FILE_URL}"
  trigger:
    project: postscriptum.app/app
    branch: ${CI_COMMIT_REF_NAME}

publish_release:
  extends: .publish-release
  release:
    assets:
      links:
        - name: "${PKG_COMMON_FILENAME}"
          url: "${PKG_JOB_COMMON_FILE_URL}"
        - name: "${PKG_FILENAME}"
          url: "${PKG_JOB_FILE_URL}"

publish_npm:
  extends: .publish-npm
  script:
    - npm config set -- "//registry.npmjs.org/:_authToken" "${PS_NPM_TOKEN}"
    - npm publish "${PKG_COMMON_FILENAME}"
    - npm publish "${PKG_FILENAME}"

